summaryrefslogtreecommitdiffstats
path: root/util/git-hooks/pre-push
diff options
context:
space:
mode:
authorStefan Tauner <stefan.tauner@gmx.at>2017-10-12 02:46:00 +0200
committerStefan Tauner <stefan.tauner@gmx.at>2017-10-12 03:16:10 +0200
commit9fbbf55ecb991704cfbb2900ad9b41a1f7647759 (patch)
tree58c5f5f6f95c2dea49264ea0ac27a2a6650a808a /util/git-hooks/pre-push
parent40ba6fd0486b9845a951dbe042b1121687353c1a (diff)
downloadflashrom-9fbbf55ecb991704cfbb2900ad9b41a1f7647759.tar.gz
flashrom-9fbbf55ecb991704cfbb2900ad9b41a1f7647759.tar.bz2
flashrom-9fbbf55ecb991704cfbb2900ad9b41a1f7647759.zip
Convert flashrom to git
- Drop support for Subversion in the getrevision script and Makefile. - Refinement of getrevision to have a single function determining the new flashrom version string (based on git describe). - Add .gitignore and .gitattributes file (the latter to limit exports). - Restore modification dates of the exported files from the VCS. - Stop exporting VCS log dumps to CHANGELOG. This makes no sense. - Export VCS metadata needed by the Makefile to versioninfo.inc - Do not export the pre-"compiled" manpage. It can be generated like anything else from the code dump with versioninfo.inc - Add some initial client-side git hooks that get installed automatically on make runs: * pre-commit: - test for whitespace errors via git diff-index --check * commit-msg: - Use the up to date hook from gerrit to add Change-Id tags. Unlike the upstream hook, add them to fixup/squash changes too to allow for our staging process. - Test for duplicate sign-offs/acks. * When pushing to one of the upstream repositories check mandatory rules: - existing signoffs and acks in all new commits - no deletions of branches - no new branches other than versioned branches (e.g., 0.0.x) - no history rewriting of branches - Various other small refinements, bikesheddings and cosmetic changes to slow down progress of flashrom and humanity as a whole. Original-Change-Id: I64eef21982cac0a0a7419bcd2c8a936672ae9cb2 Original-Reviewed-on: https://review.coreboot.org/19206 Original-Reviewed-by: Nico Huber <nico.h@gmx.de> Original-Reviewed-by: Philippe Mathieu-Daudé <f4bug@amsat.org> Change-Id: I325edb7d9890c412a44ecacb5161268d3dbccc57 Signed-off-by: Stefan Tauner <stefan.tauner@gmx.at> Signed-off-by: David Hendricks <dhendricks@fb.com> Signed-off-by: Nico Huber <nico.h@gmx.de> Reviewed-on: https://review.coreboot.org/21923 Acked-by: Stefan Tauner <stefan.tauner@gmx.at>
Diffstat (limited to 'util/git-hooks/pre-push')
-rwxr-xr-xutil/git-hooks/pre-push75
1 files changed, 75 insertions, 0 deletions
diff --git a/util/git-hooks/pre-push b/util/git-hooks/pre-push
new file mode 100755
index 000000000..b5f4620ea
--- /dev/null
+++ b/util/git-hooks/pre-push
@@ -0,0 +1,75 @@
+#!/bin/sh
+
+# A hook script to verify what is about to be pushed. Called by "git
+# push" after it has checked the remote status, but before anything has been
+# pushed. If this script exits with a non-zero status nothing will be pushed.
+#
+# This hook is called with the following parameters:
+#
+# $1 -- Name of the remote to which the push is being done
+# $2 -- URL to which the push is being done
+#
+# If pushing without using a named remote those arguments will be equal.
+#
+# Information about the commits which are being pushed is supplied as lines to
+# the standard input in the form:
+#
+# <local ref> <local sha1> <remote ref> <remote sha1>
+
+remote="$1"
+url="$2"
+
+zero=0000000000000000000000000000000000000000
+
+upstream_pattern="github\.com.flashrom/flashrom(\.git)?|flashrom\.org.git/flashrom(\.git)?"
+
+# Only care about the upstream repositories
+if echo "$url" | grep -q -v -E "$upstream_pattern" ; then
+ exit 0
+fi
+
+while read local_ref local_sha remote_ref remote_sha ; do
+
+ # Only allow the stable and staging branches as well as versioned stable branches (e.g., 0.0.x).
+ # The matching expression's RE is always anchored to the first character (^ is undefined).
+ # The outer parentheses are needed to print out the whole matched string.
+ version=$(expr ${remote_ref#*refs/heads/} : '\(\([0-9]\+\.\)\{2,\}x\)$')
+ if [ "$remote_ref" != "refs/heads/staging" ] && \
+ [ "$remote_ref" != "refs/heads/stable" ] && \
+ [ -z "$version" ]; then
+ echo "Feature branches not allowed ($remote_ref)." >&2
+ exit 1
+ fi
+
+ if [ "$local_sha" = $zero ]; then
+ echo "Deletion of branches is prohibited." >&2
+ exit 1
+ fi
+
+ # Check for Signed-off-by and Acked-by
+ commit=$(git rev-list -n 1 --all-match --invert-grep -E \
+ --grep '^Signed-off-by: .+ <.+@.+\..+>$' \
+ --grep '^Acked-by: .+ <.+@.+\..+>$' \
+ "$remote_sha..$local_sha")
+ if [ -n "$commit" ]; then
+ echo "Commit $local_sha in $local_ref is missing either \"Signed-off-by\"" \
+ " or \"Acked-by\" lines, not pushing." >&2
+ exit 1
+ fi
+
+ # Make _really_ sure we do not rewrite history of any head/branch
+ if [ "${remote_ref#*refs/heads/}" != "$remote_ref" ]; then
+ nonreachable=$(git rev-list $remote_sha ^$local_sha | head -1)
+ if [ -n "$nonreachable" ]; then
+ echo "Only fast-forward pushes are allowed on branches." >&2
+ echo "At least $nonreachable is not included in $remote_sha while pushing to " \
+ "$remote_ref" >&2
+ exit 1
+ fi
+ fi
+
+ # FIXME: check commit log format (subject without full stop at the end etc).
+ # FIXME: do buildbot checks if authorized?
+done
+
+exit 0